unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Panel2: TPanel;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    procedure Open1Click(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;


var
  Form1: TForm1;
  Temp :TBitmap;

implementation

uses
 EffectBass;

{$R *.DFM}

//------------------------------------------------------------------------------
//֐@@EffectLightMode
//pr      邳
//      hBMP           ...   rbg}bṽnh
//            Value          ...  (-255..0..255)
//߂l
//            Vrbg}bṽnh
//------------------------------------------------------------------------------
function EffectLightMode(hBMP :HBitmap;Value:Integer):HBitmap;
var
  Row,Col         : Integer;
  SrcRow,DestRow  : pRGBArray;
  SrcBitmap,DestBitmap     : TBitmap;
begin                 
  SrcBitmap   :=TBitmap.Create;
  DestBitmap  :=TBitmap.Create;
  SrcBitmap.Handle :=hBMP;
  Set24bit(SrcBitmap,DestBitmap);
  try
    for Row := 0 to SrcBitmap.Height - 1 do
    begin
      SrcRow  := SrcBitmap.Scanline[Row];
      DestRow := DestBitmap.Scanline[Row];
      for Col := 0 to SrcBitmap.Width - 1 do
      begin
          //eRGBValue𑫂
          DestRow[Col].rgbtRed   :=Set255(SrcRow[Col].rgbtRed+Value);
          DestRow[Col].rgbtGreen :=Set255(SrcRow[Col].rgbtGreen+Value);
          DestRow[Col].rgbtBlue  :=Set255(SrcRow[Col].rgbtBlue+Value) ;
      end;
    end;
     Result :=DestBitmap.ReleaseHandle;
  except
     Result :=SrcBitmap.ReleaseHandle;
  end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;


/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Temp.LoadFromFIle(OpenDialog1.FIlename);
   Image1.picture.bitmap.Assign(Temp);
   ScrollBar1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
Var
 BMP:TBitmap;
begin
   if not (ScrollCode=scTrack) then
   begin
     BMP:=TBitmap.Create;
     BMP.Assign(Temp);
     Image1.Picture.bitmap.Handle:= EffectLightMode(BMP.ReleaseHandle,ScrollPos);
     BMP.free;
   end;
end;

/////////
procedure TForm1.FormCreate(Sender: TObject);
begin
 Temp:=Tbitmap.Create;
end;

/////////
procedure TForm1.FormDestroy(Sender: TObject);
begin
 Temp.free;
end;

end.
